package com.fjhx.account.entity.account.po;

import com.baomidou.mybatisplus.annotation.TableField;
import com.ruoyi.common.core.domain.BasePo;
import com.baomidou.mybatisplus.annotation.TableName;
import java.math.BigDecimal;
import java.util.Date;
import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotBlank;

/**
 * <p>
 * 账户资金流水表
 * </p>
 *
 * @author
 * @since 2023-04-06
 */
@Getter
@Setter
@TableName("account_running_water")
public class AccountRunningWater extends BasePo {

    /**
     * 账户-管理表ID
     */
    private Long accountManagementId;

    /**
     * 业务ID
     */
    private Long businessId;

    /**
     * 收支类型：10 收入，20支出
     */
    private String status;

    /**
     * 金额
     */
    private BigDecimal amount;

    /**
     * 已认领总金额
     */
    private BigDecimal claimAmount;

    /**
     * 币种（字典account_currency）
     */
    @NotBlank(message = "币种不能为null")
    private String currency;

    /**
     * 账户名
     */
    private String name;

    /**
     * 合同到账（10:是，20:否）
     */
    private String received;

    /**
     * 开户银行
     */
    private String openingBank;

    /**
     * 开户账号
     */
    private String accountOpening;

    /**
     * 交易时间
     */
    private Date transactionTime;

    /**
     * 备注
     */
    private String remarks;

    /**
     * 是否认领
     */
    private Integer isClaim;

    /**
     * 条数
     */
    @TableField(exist = false)
    private Integer count;
}
